# This work is marked with CC0 1.0. To view a copy of this license, visit http://creativecommons.org/publicdomain/zero/1.0
import fileinput
import sys, math

def main():
	Round9(); return
	Round1()
	Round2()
	Round3()
	Round4()
	Round5()
	Round6()
	Round7()
	Round8()
	Round9()

#Empty enum/struct/class
def Round1():
	round=1
	testCount=0

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"enum EnumType{i} {{ }};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"struct StructType{i} {{ }};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"class ClassType{i} {{ public: }};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"enum EnumType{i} {{ EnumVal{i} }};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"struct StructType{i} {{ int a; }};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"class ClassType{i} {{ public: int a; }};\n")

#Def struct/class/func
def Round2():
	round=2
	testCount=0

	testCount+=1
	"""
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"enum EnumType{i};\n")
	"""
	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"struct StructType{i};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"class ClassType{i};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"int func{i}();\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"extern int var{i};\n")


# enum/enum class/struct/class with 5 members
def Round3():
	round=3
	testCount=0

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(50_000):
			f.write(f"enum class EnumType{i} {{")
			for n in range(5):
				f.write(f" Val{n},")
			f.write("};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(50_000):
			f.write(f"enum EnumType{i} {{")
			for n in range(5):
				f.write(f" EnumType{i}_Val{n},")
			f.write("};\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(50_000):
			f.write(f"struct S{i} {{ int var0")
			for n in range(1, 5):
				f.write(f", var{n}")
			f.write("; };\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(50_000):
			f.write(f"class S{i} {{ public: int var0")
			for n in range(1, 5):
				f.write(f", var{n}")
			f.write("; };\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(50_000):
			f.write(f"template<class T> class S{i} {{ public: T var0")
			for n in range(1, 5):
				f.write(f", var{n}")
			f.write("; };\n")

#func declare with inline and static mix
def Round4():
	round=4
	testCount=0

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"int func{i}();\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"int func{i}(int a);\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"int func{i}(int a, int b, int c, int d, int e);\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"int func{i}(double a, double b, double c, double d, double e);\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"int func{i}(Dummy*a, Dummy*b, Dummy*c, Dummy*d, Dummy*e);\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"int func{i}(Dummy a, Dummy b, Dummy c, Dummy d, Dummy e);\n")

	#

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"inline int func{i}() {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"inline int func{i}(int a) {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"inline int func{i}(int a, int b, int c, int d, int e) {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"inline int func{i}(double a, double b, double c, double d, double e) {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"inline int func{i}(Dummy*a, Dummy*b, Dummy*c, Dummy*d, Dummy*e) {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write("struct Dummy { int a, b, c; };\n");
		for i in range(25_000):
			f.write(f"inline int func{i}(Dummy a, Dummy b, Dummy c, Dummy d, Dummy e) {{ return 123; }}\n")


def Round5():
	round=5
	testCount=0


	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"int func{i}();\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"int func{i}() {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"inline int func{i}() {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"static int func{i}() {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"inline static int func{i}() {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"template<class T> T func{i}() {{ return 123; }}\n")


def Round6():
	round=6
	testCount=0

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"int func{i}(int p1, int p2, int p3);\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(50_000):
			f.write(f"int func{i}(int p1, int p2, int p3);\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(250_000):
			f.write(f"int func{i}(int p1, int p2, int p3);\n")


def Round7():
	round=7
	testCount=0

	""" No point testing this
	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"int func{i}(int p1, int p2, int p3) {{ return 123; }}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(5_000):
			f.write(f"int func{i}(int p1, int p2, int p3) {{ return 123; }}\n")
			f.write(f"int func{i}(int p1, double p2, int p3) {{ return 123; }}\n")
			f.write(f"int func{i}(int p1, int p2, double p3) {{ return 123; }}\n")
			f.write(f"int func{i}(double p1, double p2, int p3) {{ return 123; }}\n")
			f.write(f"int func{i}(int p1, double p2, double p3) {{ return 123; }}\n")
	"""

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(25_000):
			f.write(f"int func{i}(int p1, int p2, int p3);\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		for i in range(5_000):
			f.write(f"int func{i}(int p1, int p2, int p3);\n")
			f.write(f"int func{i}(int p1, double p2, int p3);\n")
			f.write(f"int func{i}(int p1, int p2, double p3);\n")
			f.write(f"int func{i}(double p1, double p2, int p3);\n")
			f.write(f"int func{i}(int p1, double p2, double p3);\n")


def Round8():
	round=8
	testCount=0

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write(f"struct Test {{ }};\n")
		f.write(f"int funcI(Test*p1, int p2, int p3);\n")
		f.write(f"int funcL(Test*p1, int p2, long p3);\n")
		f.write(f"int funcUI(Test*p1, int p2, unsigned int p3);\n")
		f.write(f"int funcUL(Test*p1, int p2, unsigned long p3);\n")
		for i in range(250):
			f.write(f"int func{i}() {{\n\tTest t;\n\tint v;\n")
			for n in range(25):
				f.write(f"\tv = funcI(&t, {n}, {n+1});\n")
				f.write(f"\tv = funcL(&t, {n}, {n+1}L);\n")
				f.write(f"\tv = funcUI(&t, {n}, {n+1}U);\n")
				f.write(f"\tv = funcUL(&t, {n}, {n+1}UL);\n")
			f.write(f"\treturn 0;\n}}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write(f"struct Test {{ }};\n")
		f.write(f"int funcI(Test*p1, int p2, int p3) {{ return 0; }}\n")
		f.write(f"int funcL(Test*p1, int p2, long p3) {{ return 0; }}\n")
		f.write(f"int funcUI(Test*p1, int p2, unsigned int p3) {{ return 0; }}\n")
		f.write(f"int funcUL(Test*p1, int p2, unsigned long p3) {{ return 0; }}\n")
		for i in range(250):
			f.write(f"int func{i}() {{\n\tTest t;\n\tint v;\n")
			for n in range(25):
				f.write(f"\tv = funcI(&t, {n}, {n+1});\n")
				f.write(f"\tv = funcL(&t, {n}, {n+1}L);\n")
				f.write(f"\tv = funcUI(&t, {n}, {n+1}U);\n")
				f.write(f"\tv = funcUL(&t, {n}, {n+1}UL);\n")
			f.write(f"\treturn 0;\n}}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write(f"struct Test {{ }};\n")
		f.write(f"template<class T> int func(Test*p1, int p2, T p3) {{ return 0; }}\n")
		for i in range(250):
			f.write(f"int func{i}() {{\n\tTest t;\n\tint v;\n")
			for n in range(25):
				f.write(f"\tv = func(&t, {n}, {n+1});\n")
				f.write(f"\tv = func(&t, {n}, {n+1}L);\n")
				f.write(f"\tv = func(&t, {n}, {n+1}U);\n")
				f.write(f"\tv = func(&t, {n}, {n+1}UL);\n")
			f.write(f"\treturn 0;\n}}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write(f"struct Test {{ }};\n")
		f.write(f"int func(Test*p1, int p2, int p3) {{ return 0; }}\n")
		f.write(f"int func(Test*p1, int p2, long p3) {{ return 0; }}\n")
		f.write(f"int func(Test*p1, int p2, unsigned int p3) {{ return 0; }}\n")
		f.write(f"int func(Test*p1, int p2, unsigned long p3) {{ return 0; }}\n")
		for i in range(250):
			f.write(f"int func{i}() {{\n\tTest t;\n\tint v;\n")
			for n in range(25):
				f.write(f"\tv = func(&t, {n}, {n+1});\n")
				f.write(f"\tv = func(&t, {n}, {n+1}L);\n")
				f.write(f"\tv = func(&t, {n}, {n+1}U);\n")
				f.write(f"\tv = func(&t, {n}, {n+1}UL);\n")
			f.write(f"\treturn 0;\n}}\n")


def Round9():
	round=9
	testCount=0

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write(f"struct Test {{ inline int func(int p1, int p2) {{ return 0; }} }};\n")
		for i in range(250):
			f.write(f"int func{i}() {{\n\tTest t;\n\tint v;\n")
			for n in range(100):
				f.write(f"\tv = t.func({n}, {n+1});\n")
			f.write(f"\treturn 0;\n}}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write(f"class Test {{ public: inline int func(int p1, int p2) {{ return 0; }} }};\n")
		for i in range(250):
			f.write(f"int func{i}() {{\n\tTest t;\n\tint v;\n")
			for n in range(100):
				f.write(f"\tv = t.func({n}, {n+1});\n")
			f.write(f"\treturn 0;\n}}\n")

	testCount+=1
	with open(f"test{round}_{testCount}.cpp", 'w') as f:
		f.write(f"template<class T> class Test {{ public: inline int func(int p1, T p2) {{ return 0; }} }};\n")
		for i in range(250):
			f.write(f"int func{i}() {{\n\tTest<int> t;\n\tint v;\n")
			for n in range(100):
				f.write(f"\tv = t.func({n}, {n+1});\n")
			f.write(f"\treturn 0;\n}}\n")


main()
